var connectionOptions = {
	"bitrate": 115200,
	"dataBits": "eight",
	"parityBit": "no",
	"stopBits": "one",
	"receiveTimeout": 0,
	"sendTimeout": 0,
	"name": ""
};

var connectionId = -1;
var robotPort = -1;
var selectedPort = "";
var selectedSpeed = 115200;
var connected = false;
var r_test = "";
//var test_flag=false;
var rPort = "";
var comportList=new Array(100);
var comindex=0;
var concount=0;

$(function() {
	
	connected = false;
	robotPort = -1;
	
	//alert(getLang());
	// get the available COM posts and add them to the combo list
	chrome.serial.getDevices(function(ports) {
				
		// sort the ports based on their names (path)
		ports.sort(function(a, b) {
			a = a.path.replace("COM", "");
			b = b.path.replace("COM", "");
			return a-b;
		});
				
		for (var i = 0; i < ports.length; i++) {
			var portName = ports[i].path;
			comportList[comindex++]=ports[i].path; 
		}

		dolast();
	});
	
	/* bind a click event on the "send" button
	$("#send_button").bind("click", function(event, ui) {
		if(connected) {	// send data from MakeJson
			chrome.serial.send(robotPort, myArrayBuffer(commandset), function(sendInfo) {
				if(sendInfo.error) colsole.log("Send Error");
				else console.log("send OK");
			});
		}
	});	 */
	
	$("#playButton").bind("click", function(event, ui){
		//alert("play");
		makeJson();  
							
		if(connected) {	// send data from MakeJson			
			chrome.serial.send(robotPort, myArrayBuffer(commandset), function(sendInfo) {
				if(sendInfo.error) colsole.log("Send Error");
				else console.log("send OK");
			});
		}		
//		chrome.serial.disconnect(connectionId, onDisconnect);
/*
         var src = ($("#playIcon").attr("src") === "img/play.png") 
            ? "img/play_on.png" 
            : "img/play.png"; 
         $("#playIcon").attr("src", src); 
*/		 
//		$("#playButton").attr("src","play_on.png"); 

	});

	$("#playButton").bind("mousedown", function(event, ui){
		$("#playIcon").attr("src","img/play_on.png");
	});

	$("#playButton").bind("mouseup", function(event, ui){
		$("#playIcon").attr("src","img/play.png");
	});
	
	$("#reconnect").bind("click", function(event, ui){
		if(document.getElementById('reconnect').innerHTML=="Try Researching"){
			chrome.runtime.reload();
		}
	});

	$("#helpopen").bind("click", function(event, ui){
		document.getElementById('helpme').style.visibility="visible";
		var lang = getLang();
		switch(lang){
			case 'ko':
				document.getElementById('help').src="img/help_ko.png";
				break;
			case 'ja':
				document.getElementById('help').src="img/help_ja.png";
				break;
			default:
				document.getElementById('help').src="img/help_en.png";
				break;
		}
		console.log('OKOK')
	});

	$("#helpme").bind("click", function(event, ui){
		document.getElementById('helpme').style.visibility="hidden";
	});




});


function setStatus(status) {
//  document.getElementById('status').innerText = status;
	document.getElementById('reconnect').innerHTML = status; 
}

function dolast(){
	console.log("Start Searching "+comindex);
	for(var i=0;i<comindex;i++){
		myconnectPort(comportList[i]);
		sleep(600);
	}
}

function sleep(num){	//
 var now = new Date();
   var stop = now.getTime() + num;
   while(true){
 now = new Date();
 if(now.getTime() > stop)return;
 }
}

function myconnectPort(cport){
	selectedPort = cport;
	if(!connected) {
		// try to connect to the selected port with the selected speed
		console.log("Try:"+selectedPort);
		connectionOptions.name=cport;		
		chrome.serial.connect(selectedPort, connectionOptions, onConnect);
		return 1;
	}
	else {
		// try to connect to the selected port
		console.log("Try Fail:"+selectedPort);
		chrome.serial.disconnect(connectionId, onDisconnect);
		return 0;
	}
}

/* Converts a string to UTF-8 encoding in a Uint8Array; returns the array */
var StrToBytes = function(str) {
   var encodedString = unescape(encodeURIComponent(str));
   var bytes = new Uint8Array(encodedString.length);
   for (var i = 0; i < encodedString.length; ++i) {
      bytes[i] = encodedString.charCodeAt(i);
   }
   return bytes.buffer;
};


function sendTest(connectionId, msg){
	
	var cmdBuf = new ArrayBuffer(20);
	var bufView = new Uint8Array(cmdBuf);
	for(var i=0;i<20;i++){
		bufView[i]=0xFE;
	}
	
	//Send Test Packet
	if(connectionId) {

		chrome.serial.send(connectionId, StrToBytes(msg), function(sendInfo) {
			if(sendInfo.error) colsole.log("Send Error");
			else console.log("Send : "+ msg + ", LEN:" + sendInfo.bytesSent);
		});
	}
	//Receive the Answer
}

// convert a string to array buffer
var myArrayBuffer=function(cset) {
	var buf = new ArrayBuffer(cindex); //get length of commandset from start.js
	var bufView = new Uint8Array(buf);
	for (var i = 0; i < cindex; i++) bufView[i] = cset[i];
	return buf;
};

// Callback function for the connect method
function onConnect(connectionInfo) {

	console.log("onConnect IN:"+connectionId);
	concount++;
	
	// check if the connection was successful
	if(connectionInfo) {
		
		connectionId = connectionInfo.connectionId;
		chrome.serial.onReceive.addListener(onReceive);
		console.log("Connect to " + connectionId + " NAME:"+connectionInfo.name);
		var WhoAmI = "?";

		//sendTest(connectionId, WhoAmI); 
		var msg=WhoAmI;
		//Send Test Packet
		if(connectionId) {

			chrome.serial.send(connectionId, StrToBytes(msg), function(sendInfo) {
				if(sendInfo.error) colsole.log("Send Error");
				else console.log("Send : "+ msg + ", LEN:" + sendInfo.bytesSent);
			});
		}
		
		if (comportList[comindex-1]==connectionInfo.name && robotPort==-1){ //Final Try Fail
			setStatus("Try Researching");
		}
	// if not, show the error message
	} else {
		if (chrome.runtime.lastError && chrome.runtime.lastError.message) 
			errorMsg = chrome.runtime.lastError.message;
		else 
			errorMsg = "Failed to connect to the port.";
		console.log("Connection Fail"+errorMsg);
	}
	
	if (concount==comindex && robotPort==-1){ //Final Try Fail
		setStatus("Try Researching");
	}
}

// Callback function for the disconnect method
function onDisconnect(result) {

	console.log("onDisconnect IN");
	
	if(result) {
		connected = false;
	} 
	else console.log('Unable to disconnect');
}

// Callback function when new data is received
function onReceive(info) {
	test_flag=false;
	if(info.data){
		var str = convertArrayBufferToString(info.data);
		r_test = str;
		if(r_test!=""){
			if(!test_flag){
				robotPort = info.connectionId;
				test_flag = true;
				connected = true;
				console.log("Robot Found: " + r_test+" ID:"+robotPort);
				setStatus(str + '\n' + " Dongle Connected");
				r_test="";
			}
		}
	}
}

// Convert an array buffer to string
function convertArrayBufferToString(buf) {
	
	var bufView = new Uint8Array(buf);
	var encodedString = String.fromCharCode.apply(null, bufView);
	return decodeURIComponent(encodedString);
}

// convert a string to array buffer
var convertStringToArrayBuffer=function(str) {
	
	var buf = new ArrayBuffer(str.length);
	var bufView = new Uint8Array(buf);
	for (var i = 0; i < str.length; i++) bufView[i] = str.charCodeAt(i);
	return buf;
};

function getLang() {
  var userLang = navigator.language || navigator.userLanguage;
  return userLang;
}


